﻿Module Module1

    Private mastrStateAbbrev() As String
    Private mastrStateName() As String

    Public Sub Main()

        Dim strTestAbbrev As String
        Dim strTestName As String

        LoadStateData()

        Console.Write("Enter a state abbreviation (or just press Enter to quit): ")
        strTestAbbrev = UCase(Console.ReadLine())

        Do Until strTestAbbrev = ""
            strTestName = GetStateName(strTestAbbrev)

            If strTestName = "" Then
                Console.WriteLine("No state name found for '" & strTestAbbrev & "'.")
            Else
                Console.WriteLine("'" & strTestAbbrev & "' is the abbreviation for '" & strTestName & "'.")
            End If
            Console.WriteLine()
            Console.Write("Enter a state abbreviation (or just press Enter to quit): ")
            strTestAbbrev = UCase(Console.ReadLine())
        Loop

    End Sub


    Private Sub LoadStateData()

        Dim intStateFileNbr As Integer
        Dim intStateUB As Integer

        intStateFileNbr = FreeFile()
        intStateUB = -1

        FileOpen(intStateFileNbr, _
                 My.Application.Info.DirectoryPath & "\STATES.DAT", _
                 OpenMode.Input)

        Do Until EOF(intStateFileNbr)
            intStateUB += 1
            ReDim Preserve mastrStateAbbrev(intStateUB)
            ReDim Preserve mastrStateName(intStateUB)
            Input(intStateFileNbr, mastrStateAbbrev(intStateUB))
            Input(intStateFileNbr, mastrStateName(intStateUB))
        Loop

        FileClose(intStateFileNbr)

    End Sub

    Private Function GetStateName(ByVal pstrTestAbbrev As String) As String

        Dim intPosition As Integer

        intPosition = Array.BinarySearch(mastrStateAbbrev, pstrTestAbbrev)

        If intPosition < 0 Then
            Return ""
        Else
            Return mastrStateName(intPosition)
        End If

    End Function

End Module
